<template>
  <aside class="sidebar">
    <section class="section">
      <h4 for="pedal" class="label">
        Add a Pedalboard {{ pedalboard }}
      </h4>
      <select name="pedal" id="pedal" class="select" v-model="pedalboard">
        <option value="" selected disabled>Select a pedalboard</option>
        <option
          v-for="board in pedalboards"
          :key="`add_pedalboard_dropdown_item_${board.pedalboard_id}}`"
          :value="board.pedalboard_id">
          {{ board.title }}  
        </option>
      </select>
      <form class="form" v-if="pedalboard === 'custom'">
        <fieldset class="fieldset">
          <label for="width">Width</label>
          <input class="width_input" type="text" id="width" name="width" placeholder="20" v-model.number="width">
        </fieldset>
        <fieldset class="fieldset">
          <label for="height">Height</label>
          <input class="height_input" type="text" name="height" id="height" placeholder="16" v-model.number="height">
        </fieldset>
      </form>
      <button class="button" @click="addPedalboard">
        Add Pedalboard
      </button>
    </section>
    <section class="section">
      <h4 for="pedal" class="label">
        Add a Pedal
      </h4>
      <select name="pedal" id="pedal" class="select" v-model="pedal">
        <option value="" selected disabled>Select a pedal</option>
        <option 
          v-for="pedal in pedals" 
          :key="`add_pedal_dropdown_item_${pedal.pedal_id}`" 
          :value="pedal.pedal_id"
          :disabled="!!pedal.separator">
          {{ pedal.title }}
        </option>
      </select>
      <button class="button" @click="addPedal">
        Add Pedal
      </button>
    </section>
  </aside>
</template>
<script>
import { mapState } from 'vuex'
const PEDALBOARD_TITLES = {
  'classic1': 'Classic 1',
  'classic3': 'Classic 3',
  'custom': 'Custom'
}
export default {
  data() {
    return {
      pedal: '',
      pedalboard: '',
      width: null,
      height: null
    }
  },
  computed: {
    ...mapState(['pedals', 'pedalboards']),
    selectedPedal() {
      if (!!this.pedals && Array.isArray(this.pedals) && !!this.pedal) {
        return this.pedals.find(p => p.pedal_id === this.pedal)
      }
    },
    selectedPedalboard() {
      this.pedalboards.forEach(pb => {
        console.log(pb.pedalboard_id, this.pedalboard)
      })
      if (!!this.pedalboards && Array.isArray(this.pedalboards) && !!this.pedalboard) {
        return this.pedalboards.find(p => p.pedalboard_id === this.pedalboard)
      }
    }
  },
  methods: {
    addPedal() {
      this.$emit('addPedal', this.selectedPedal)
    },
    addPedalboard() {
      const payload = {
        pedalboard_id: this.pedalboard,
        title: PEDALBOARD_TITLES[this.pedalboard],
        type: this.pedalboard,
        top: 15,
        bottom: 15,
        z: 0
      }

      if (this.pedalboard === 'custom') {
        payload.width = this.width
        payload.height = this.height
      }

      this.$emit('addPedalboard', payload)
    }
  }
}
</script>
<style lang="scss" scoped>
.sidebar {
  background-color: #282d30;
  max-width: 290px;
  box-shadow: 0 1px 5px rgba(0, 0, 0, .16);
  display: flex;
  flex-flow: column;
  position: fixed;
  z-index: 1000;
  height: 100vh;
}

.section {
  padding: 20px;
  border-top: 1px solid rgba(0, 0, 0, .2);

  &:first-child {
    border-top: 0;
  }
}

.label {
  margin: 0 0 14px;
  color: rgb(178, 172, 191);
}

.select {
  width: 100%;
  border-radius: 4px;
  color: #b2acbf;
  padding: 10px;
  text-overflow: ellipsis;
  white-space: nowrap;
  background: #2e3337;
  border: 1px solid rgba(255, 255, 255, .1);
}

.button {
  cursor: pointer;
  margin-top: 10px;
  background-color: #8582ff;
  display: block;
  width: 100%;
  border: 0;
  color: #fff;
  border-radius: 4px;
  padding: 10px;
  transition: background-color 0.25s ease-in-out;

  &:hover {
    background-color: #534fff;
  }
}

.form {
  display: flex;
  margin-top: 10px;
}

.fieldset {
  display: flex;
  flex-flow: column;
  margin: 0;
  border: 0;
  padding: 0;

  label {
    font-size: 12px;
    color: #b2acbf;
    margin-bottom: 5px;
  }

  input {
    box-sizing: border-box;
    width: 100%;
    height: 34px;
    padding: 6px 12px;
    background: #2e3337;
    border: 1px solid rgba(255,255,255,.1);
    color: #b2acbf;

    &.width_input {
      border-radius: 4px 0 0 4px;
    }

    &.height_input {
      border-radius: 0 4px 4px 0;
      border-left: 0;
    }
  }
}
</style>